【蓝桥杯】递增三元组 (二分, lower_bound, upper_bound)

2024-01-06 18:08

本文主要是介绍【蓝桥杯】递增三元组 (二分, lower_bound, upper_bound),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

有三个数组A,B,C,每个数组中有n个数,你可以从每个数组中找一个数,使得Ai<Bj<Ck ,(1<=I,j,k<=n)(1<=n<=100000,1<=Ai,Bj,Ck<=1000000),求最多可以组出多少三元组

Input

有多组输入
第一行输入n
接下来三行输入A,B,C三个数组,每个数组n个数

Output

每行一个整数,表示最多有多少三元组

Sample Input

3
1 1 1
2 2 2
3 3 3
3
1 2 3
1 2 3
1 2 3
Sample Output

27
1

思路分析:

看n的数据,时间复杂度只能在O(n)或者O(ngln)了。
其实仔细分析可以想到排序之后,可以用到二分查找。那么怎么设计呢?
一开始我是想的遍历a,这样b数组就得找第一个比a[i]大的数b[j],c数组找第一个比b[j]大的数c[k]. 但是在草稿纸模拟一下发现根本不可行,b数组如果不遍历会把一些重复的元素算进去。因此我选择遍历b数组。
于是,在a数组找比b[j]小的索引i,在c数组找比b[j]大的索引k. 这样可以用lower_bound和upper_bound找出来,然后根据排列组合的乘法原理求出答案。
这里顺带介绍一下lower_bound和upper_bound用法。
lower_bound(a,a+n,k)表示在a数组[0,n)里找第一个大于等于k的值的迭代器。
upper_bound(a,a+n,k)表示b数组[0,n)里找第一个大于k的值的迭代器。
lower_bound(a,a+n,k)-a表示第一个大于等于k的值的索引。
distance(a,b)表示迭代器a和b之间的元素个数( [a,b) ). (注意a的位置要小于b,不然会报错).
distance的用处在于集合set里,set是一个平衡树,并不是连续的内存空间,想获取元素个数只能用distance.

#include <bits/stdc++.h>
using namespace std;int main()
{int a[] = {1,2,2,3,3,5}, index_a, n = 6;index_a = lower_bound(a,a+n,2)-a;	//索引 1 cout<<index_a<<endl;index_a = distance(a, lower_bound(a,a+n,2));	//索引 1 cout<<index_a<<endl;index_a = upper_bound(a,a+n,2)-a;	//索引 3 cout<<index_a<<endl;index_a = distance(a, upper_bound(a,a+n,2));	//索引 3 cout<<index_a<<endl;index_a = lower_bound(a,a+n,5)-a;	//索引 5cout<<index_a<<endl;index_a = upper_bound(a,a+n,5)-a;	//超出范围,索引 6 cout<<index_a<<endl;
} 

介绍完lower_bound和upper_bound后,来分析一波。
我们遍历b数组,在a数组找比b[j]小的个数,在c数组找比b[j]大的个数.
第一个直接lower_bound(a.begin(), a.end(), b[i]) - a.begin();
lower_bound在a数组找到第一个比b[j]大于等于的数的索引,那么个数就是这个索引-a.begin().因为个数是在左闭右开的区间里,因为右开,所以区间里所有的数都比b[j]小。

第二个直接index_b = upper_bound(c.begin(), c.end(), b[i])- c.begin()求出第一个大于b[j]的数的索引,n-index_b就是索引区间[b,n)的个数。

最后,根据乘法原理,两个个数相乘。不过这两个值都可能在105,相乘会爆int范围,这个要注意!!!不然就WA掉了,而且很难察觉!

另外,这道题不需要去重,不可思议。

下面上代码。

#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
#define MAX 100010
using namespace std;int main()
{ll ans;int n, x;while(cin>>n){ans = 0;vector<int> a, b, c;for(int i = 0;i < n;i++)scanf("%d",&x), a.push_back(x);for(int i = 0;i < n;i++)scanf("%d",&x), b.push_back(x);for(int i = 0;i < n;i++)scanf("%d",&x), c.push_back(x);sort(a.begin(), a.end());sort(b.begin(), b.end());sort(c.begin(), c.end());for(int i = 0;i < n;i++){
//			if(b[i] == b[i-1]) continue;	不需要去重 ll index_a = lower_bound(a.begin(), a.end(), b[i]) - a.begin(); //索引a ll index_c = upper_bound(c.begin(), c.end(), b[i])- c.begin();	//索引c 
//			cout<<index_a<<" "<<index_c<<endl;ans += index_a * (n-index_c);}cout<<ans<<endl;}return 0;
}

这篇关于【蓝桥杯】递增三元组 (二分, lower_bound, upper_bound)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/577161

相关文章

hdu2241(二分+合并数组)

题意:判断是否存在a+b+c = x,a,b,c分别属于集合A,B,C 如果用暴力会超时,所以这里用到了数组合并,将b,c数组合并成d,d数组存的是b,c数组元素的和,然后对d数组进行二分就可以了 代码如下(附注释): #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<que

hdu2289(简单二分)

虽说是简单二分,但是我还是wa死了  题意:已知圆台的体积,求高度 首先要知道圆台体积怎么求:设上下底的半径分别为r1,r2,高为h,V = PI*(r1*r1+r1*r2+r2*r2)*h/3 然后以h进行二分 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#includ

poj 2976 分数规划二分贪心(部分对总体的贡献度) poj 3111

poj 2976: 题意: 在n场考试中,每场考试共有b题,答对的题目有a题。 允许去掉k场考试,求能达到的最高正确率是多少。 解析: 假设已知准确率为x,则每场考试对于准确率的贡献值为: a - b * x,将贡献值大的排序排在前面舍弃掉后k个。 然后二分x就行了。 代码: #include <iostream>#include <cstdio>#incl

poj 3104 二分答案

题意: n件湿度为num的衣服,每秒钟自己可以蒸发掉1个湿度。 然而如果使用了暖炉,每秒可以烧掉k个湿度,但不计算蒸发了。 现在问这么多的衣服,怎么烧事件最短。 解析: 二分答案咯。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <c

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c

poj 2594 二分图最大独立集

题意: 求一张图的最大独立集,这题不同的地方在于,间接相邻的点也可以有一条边,所以用floyd来把间接相邻的边也连起来。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <sta

poj 3692 二分图最大独立集

题意: 幼儿园里,有G个女生和B个男生。 他们中间有女生和女生认识,男生男生认识,也有男生和女生认识的。 现在要选出一些人,使得这里面的人都认识,问最多能选多少人。 解析: 反过来建边,将不认识的男生和女生相连,然后求一个二分图的最大独立集就行了。 下图很直观: 点击打开链接 原图: 现图: 、 代码: #pragma comment(

poj 2112 网络流+二分

题意: k台挤奶机,c头牛,每台挤奶机可以挤m头牛。 现在给出每只牛到挤奶机的距离矩阵,求最小化牛的最大路程。 解析: 最大值最小化,最小值最大化,用二分来做。 先求出两点之间的最短距离。 然后二分匹配牛到挤奶机的最大路程,匹配中的判断是在这个最大路程下,是否牛的数量达到c只。 如何求牛的数量呢,用网络流来做。 从源点到牛引一条容量为1的边,然后挤奶机到汇点引一条容量为m的边

二分最大匹配总结

HDU 2444  黑白染色 ,二分图判定 const int maxn = 208 ;vector<int> g[maxn] ;int n ;bool vis[maxn] ;int match[maxn] ;;int color[maxn] ;int setcolor(int u , int c){color[u] = c ;for(vector<int>::iter

POJ2413二分

注意二分, 上界。 import java.beans.beancontext.BeanContext;import java.io.BufferedReader;import java.io.IOException;import java.io.InputStream;import java.io.InputStreamReader;import java.io.PrintWrite